import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Diagrama_TTT extends PApplet {

int[] cor = new int[7];
int c = color(255);
int x1, x2, y, p = 0, q = 0, x, k = 0, r = 0, a = 0, t = 0, w = 0, contador = 0;
int i = 0, j, passe = 0;
float x0 = 41, x0_2 = 45, speed = .3f, aux1 = 0, aux2 = 100, aux12 = 0, aux22 = 100, pct, pct2, mouse_x, pmouse_x, xm1, xm2 ;
PFont fonte1, fonte2, fonte3, fonte4, fonte5, fonte6, fonte7;
Faixas[] f = new Faixas[7];
Curvas[] s = new Curvas[7];
PImage perlita, austenita, trans, seta, fechar, foto, play, retornar, pgrossa, pfina, forw, back;
PImage grao1, grao2, grao3, grao4, grao5, g1, g2, g3, g4, g5;
int flag = 0;
PGraphics pg;
float raio[];

public void setup() {
  
  size(800, 600);
  background(255);
  randomSeed(25); // ?
  raio = new float[4];
  for(j = 0; j < 4; j++)
    raio[j] = 0;
  pg = createGraphics(100, 100, P2D);
  fonte1 = loadFont("Candara-BoldItalic-18.vlw");
  fonte2 = loadFont("Candara-BoldItalic-14.vlw");
  fonte3 = loadFont("Candara-BoldItalic-35.vlw");
  fonte4 = loadFont("Candara-BoldItalic-30.vlw");
  fonte5 = loadFont("Candara-BoldItalic-24.vlw");
  fonte6 = loadFont("Candara-BoldItalic-10.vlw");
  fonte7 = loadFont("Candara-BoldItalic-12.vlw");
  foto = loadImage("foto.png");
  forw = loadImage("forw.png");
  back = loadImage("back.png");
  play = loadImage("play.png");
  pgrossa = loadImage("pgrossa.jpg");
  pfina = loadImage("pfina.jpg");
  retornar = loadImage("return.png");
  austenita = loadImage("austenita2.png");
  perlita = loadImage("perlita2.png");
  trans = loadImage("transformacao.png");
  seta = loadImage("seta.png");
  fechar = loadImage("close.png");
  grao1 = loadImage("grao1.png");
  grao2 = loadImage("grao2.png");
  grao3 = loadImage("grao3.png");
  grao4 = loadImage("grao4.png");
  grao5 = loadImage("grao5.png");
  
  g1 = loadImage("g21.png");
  g2 = loadImage("g22.png");
  g3 = loadImage("g23.png");
  g4 = loadImage("g24.png");
  g5 = loadImage("g25.png");
  smooth();
  stroke(0);
  strokeWeight(2);
  noFill();
  translate(-10, 60);
  bezier(90, 500, 90, 480, 80, 365, 500, 348);
  bezier(160, 500, 160, 490, 150, 380, 500, 370);
  resetMatrix();
  for(y = 550; y >= 430; y-= 20) {
    c = color(255);
    for(x1 = 38; x1 <= 452; x1++) {
      c = get(x1, y);
      if(c == color(0))
        break;
    }
    c = color(255);
    for(x2 = x1 + 5; x2 <= 452; x2++) {
      c = get(x2, y);
        if(c == color(0))
          break;
    }
    cor[i] = color(random(50, 200), random(100, 200), random(20, 200));
    s[i] = new Curvas(x1, 280, x2 - x1, 240, cor[i]);
    f[i] = new Faixas(x1, y, x2 - x1, cor[i]);
    i++;
  }
  textFont(fonte1);
  textAlign(LEFT);
  smooth();
  stroke(0);
  strokeWeight(1);
  for (i = 0; i <= 57; i++){
    line(40 + 8*i, 40, 44 + 8*i, 40);
    line(40 + 8*i, 160, 44 + 8*i, 160);
    line(40 + 8*i, 403, 44 + 8*i, 403);
  }
  
  // Curvas de transforma\u00e7\u00e3o - desenhando os eixos
  
  fill(0);
  strokeWeight(2);
  line(40, 30, 40, 280);
  line(40, 280, 500, 280);
  text("Tempo (s)", 504, 273);
  text("Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica", 208, 24);
  textFont(fonte6);
  text("0", 87, 287);
  text("1", 157, 287);
  text("2", 227, 287);
  text("3", 298, 287);
  text("4", 366, 287);
  text("5", 438, 287);
  textFont(fonte2);
  text("% em massa de austenita\n     transformada em perlita", 38, 15);
  text("100", 15, 43);
  text("50", 20, 163);
  text("10", 72, 292);
  text("10", 142, 292);
  text("10", 212, 292);
  text("10", 283, 292);
  text("10", 351, 292);
  text("10", 423, 292);
  triangle(38, 30, 42, 30, 40, 27);
  triangle(500, 278, 500, 282, 503, 280);
  for(i = 0; i <= 5; i++) {
    line(81 + 70*i, 280, 81 + 70*i, 277);
  }
  
  // Diagrama TTT - desenhando os eixos
  
  text("10", 72, 582);
  text("10", 142, 582);
  text("10", 212, 582);
  text("10", 283, 582);
  text("10", 351, 582);
  text("10", 423, 582);
  text("550", 14, 537);
  text("600", 14, 502);
  text("650", 14, 467);
  text("700", 14, 432);
  text("750", 14, 397);
  text("800", 14, 362);
  textFont(fonte6);
  text("0", 87, 577);
  text("1", 157, 577);
  text("2", 227, 577);
  text("3", 298, 577);
  text("4", 366, 577);
  text("5", 438, 577);
  textFont(fonte1);
  line(40, 320, 40, 570);
  line(40, 570, 500, 570);
  text("Tempo (s)", 504, 563);
  text("Temperatura (\u00b0C)", 48, 324);
  triangle(38, 320, 42, 320, 40, 317);
  triangle(500, 568, 500, 572, 503, 570);
  for(i = 0; i <= 5; i++)
    line(81 + 70*i, 570, 81 + 70*i, 567);
  for(i = 0; i <= 5; i++)
    line(40, 535 - 35*i, 43, 535 - 35*i);
  fill(131, 219, 227);
  strokeWeight(8);
  strokeJoin(ROUND);
  stroke(131, 219, 227, 100);
  rect(595, 60, 170, 30);
  rect(595, 105, 170, 30);
  rect(595, 150, 170, 30);
  rect(583, 305, 194, 225);
  fill(0);
  text(" Iniciar anima\u00e7\u00e3o", 595, 545, 170, 30);
  textAlign(CENTER);
  text("Instru\u00e7\u00f5es", 595, 65, 170, 30);
  text("Cr\u00e9ditos", 595, 110, 170, 30);
  text("Refer\u00eancias", 595, 155, 170, 30);
  
  fill(0, 0, 255);
  text("Sobre a anima\u00e7\u00e3o", 595, 275, 170, 30);
  
  fill(0);
  image(play, 730, 540);
  textFont(fonte2);
  text("A anima\u00e7\u00e3o ilustra a constru\u00e7\u00e3o do Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura (Diagrama TTT) de um a\u00e7o com composi\u00e7\u00e3o eutet\u00f3ide (99,24%p Fe + 0,76%p C), a partir das Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica de austenita em perlita, representadas a v\u00e1rias temperaturas.", 585, 312, 190, 250);
  noStroke();
  fill(193, 241, 245, 200);
  rect(0, 0, 900, 600);
  fill(131, 219, 227);
  strokeWeight(8);
  strokeJoin(ROUND);
  stroke(131, 219, 227, 100);
  rect(150, 150, 500, 300);
  fill(0);
  textFont(fonte3); //35
  textAlign(CENTER);
  text("Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura\n(Diagrama TTT)", 150, 170, 500, 200);
  textFont(fonte1);
  text("Amostra: a\u00e7o com composi\u00e7\u00e3o eutet\u00f3ide\n(99,24%p Fe + 0,76%p C)", 150, 318, 500, 80);
  textFont(fonte4);//30
  text("Clique para come\u00e7ar", 150, 380, 500, 80);
  xm1 = f[6].get_x1();
  xm2 = f[0].get_x1();
}

public void draw () {
  
  if(p == 0) { // Tela inicial; p assume 1 quando o usu\u00e1rio "clica para come\u00e7ar"
    textFont(fonte1);
    textAlign(LEFT);
    smooth();
    stroke(0);
    strokeWeight(1);
    for (i = 0; i <= 57; i++){
      line(40 + 8*i, 40, 44 + 8*i, 40);
      line(40 + 8*i, 160, 44 + 8*i, 160);
      line(40 + 8*i, 403, 44 + 8*i, 403);
    }
    
    // Curvas de transforma\u00e7\u00e3o - desenhando os eixos
    
    fill(0);
    strokeWeight(2);
    line(40, 30, 40, 280);
    line(40, 280, 500, 280);
    text("Tempo (s)", 504, 273);
    text("Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica", 208, 24);
    //text("% em massa de austenita\ntransformada em perlita", 35, 28);
    textFont(fonte6);
    text("0", 87, 287);
    text("1", 157, 287);
    text("2", 227, 287);
    text("3", 298, 287);
    text("4", 366, 287);
    text("5", 438, 287);
    textFont(fonte2); // tamanho 14
    text("% em massa de austenita\n     transformada em perlita", 38, 15);
    text("100", 15, 43);
    text("50", 20, 163);
    text("10", 72, 292);
    text("10", 142, 292);
    text("10", 212, 292);
    text("10", 283, 292);
    text("10", 351, 292);
    text("10", 423, 292);
    triangle(38, 30, 42, 30, 40, 27);
    triangle(500, 278, 500, 282, 503, 280);
    for(i = 0; i <= 5; i++) {
      line(81 + 70*i, 280, 81 + 70*i, 277);
    }
    
    // Diagrama TTT - desenhando os eixos
    
    text("10", 72, 582);
    text("10", 142, 582);
    text("10", 212, 582);
    text("10", 283, 582);
    text("10", 351, 582);
    text("10", 423, 582);
    text("550", 14, 537);
    text("600", 14, 502);
    text("650", 14, 467);
    text("700", 14, 432);
    text("750", 14, 397);
    text("800", 14, 362);
    textFont(fonte6);
    text("0", 87, 577);
    text("1", 157, 577);
    text("2", 227, 577);
    text("3", 298, 577);
    text("4", 366, 577);
    text("5", 438, 577);
    textFont(fonte1);
    line(40, 320, 40, 570);
    line(40, 570, 500, 570);
    text("Tempo (s)", 504, 563);
    text("Temperatura (\u00b0C)", 48, 324);
    triangle(38, 320, 42, 320, 40, 317);
    triangle(500, 568, 500, 572, 503, 570);
    for(i = 0; i <= 5; i++)
      line(81 + 70*i, 570, 81 + 70*i, 567);
    for(i = 0; i <= 5; i++)
      line(40, 535 - 35*i, 43, 535 - 35*i);
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    rect(595, 60, 170, 30);
    rect(595, 105, 170, 30);
    rect(595, 150, 170, 30);
    rect(583, 305, 194, 225);
    fill(0);
    text(" Iniciar anima\u00e7\u00e3o", 595, 545, 170, 30);
    textAlign(CENTER);
    text("Instru\u00e7\u00f5es", 595, 65, 170, 30);
    text("Cr\u00e9ditos", 595, 110, 170, 30);
    text("Refer\u00eancias", 595, 155, 170, 30);
    image(play, 730, 540);
    
    fill(0, 0, 255);
    text("Sobre a anima\u00e7\u00e3o", 595, 275, 170, 30);
    
    fill(0);
    textFont(fonte2);
    text("A anima\u00e7\u00e3o ilustra a constru\u00e7\u00e3o do Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura (Diagrama TTT), de um a\u00e7o com composi\u00e7\u00e3o eutet\u00f3ide (99,24%p Fe + 0,76%p C), a partir das Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica de austenita em perlita, representadas a v\u00e1rias temperaturas.", 585, 312, 190, 250);
    noStroke();
    fill(193, 241, 245, 200);
    rect(0, 0, 900, 600);
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    rect(150, 150, 500, 300);
    fill(0);
    textFont(fonte3); //35
    textAlign(CENTER);
    text("Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura\n(Diagrama TTT)", 150, 170, 500, 200);
    textFont(fonte1);
    text("Amostra: a\u00e7o com composi\u00e7\u00e3o eutet\u00f3ide\n(99,24%p Fe + 0,76%p C)", 150, 318, 500, 80);
    textFont(fonte4);//30
    text("Clique para come\u00e7ar", 150, 380, 500, 80);
  }
  else { // o usu\u00e1rio j\u00e1 iniciou a anima\u00e7\u00e3o
    background(255);
    smooth();
    stroke(0);
    strokeWeight(1);
    for (i = 0; i <= 57; i++){
      line(40 + 8*i, 40, 44 + 8*i, 40);
      line(40 + 8*i, 160, 44 + 8*i, 160);
      line(40 + 8*i, 403, 44 + 8*i, 403);
    }
    
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    if(flag != 5) {
      rect(595, 60, 170, 30);
      rect(595, 105, 170, 30);
      rect(595, 150, 170, 30);
      rect(583, 305, 194, 225);
    }
    else {
      rect(600, 20, 170, 30);
      rect(600, 65, 170, 30);
      rect(600, 110, 170, 30);
    }
    fill(0);
    textFont(fonte1);
    textAlign(LEFT);
    if(flag == 0) {
      text(" Iniciar anima\u00e7\u00e3o", 595, 545, 170, 30);
      image(play, 730, 540);
      textFont(fonte1);
      textAlign(CENTER);
      fill(0, 0, 255);
      text("Sobre a anima\u00e7\u00e3o", 595, 275, 170, 30);
      fill(0);
      textFont(fonte2);
      text("A anima\u00e7\u00e3o ilustra a constru\u00e7\u00e3o do Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura (Diagrama TTT), de um a\u00e7o com composi\u00e7\u00e3o eutet\u00f3ide (99,24%p Fe + 0,76%p C), a partir das Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica de austenita em perlita, representadas a v\u00e1rias temperaturas.", 585, 312, 190, 250);
    }
    else if(flag != 4 && flag != 5) {
      text(" Continuar", 620, 545, 170, 30);
      image(play, 710, 540);
      textAlign(CENTER);
      if(flag == 1) {
        fill(0, 0, 255);
        textFont(fonte1);
        text("Parte 1", 595, 275, 170, 30);
        fill(0);
        textFont(fonte2);
        text("A partir da curva de transforma\u00e7\u00e3o de austenita em perlita a " + (550 - 150/7) + " \u00b0C, descartando a informa\u00e7\u00e3o relativa \u00e0 porcentagem em massa da transforma\u00e7\u00e3o, registra-se no Diagrama TTT uma isoterma a 529 \u00b0C com largura definida pelo tempo total da transforma\u00e7\u00e3o." , 590, 325, 183, 200);
      }
      else if(flag == 2) {
       fill(0, 0, 255);
       textFont(fonte1);
       text("Parte 2", 595, 275, 170, 30);
       fill(0);
       text("Adota-se o mesmo procedimento para constru\u00e7\u00e3o da faixa de transforma\u00e7\u00e3o temporal a " + (700 - 200/7) + "\u00b0C.", 587, 358, 190, 200);
      }
      else if(flag == 3) {
       fill(0, 0, 255);
       textFont(fonte1);
       text("Parte 3", 595, 275, 170, 30);
       fill(0);
       textFont(fonte2);
       text("Repetindo o procedimento para v\u00e1rias temperaturas, obt\u00eam-se as faixas de transforma\u00e7\u00e3o temporal correspondentes, conforme mostrado no gr\u00e1fico ao lado.", 597, 345, 170, 180);
      }
    }
    else {
      if(flag == 4) {
        text("    Reiniciar", 620, 543, 170, 30);
        image(retornar, 710, 534);
        textFont(fonte1);
        image(play, 708, 565);
        text("   Extras", 635, 586);
        textAlign(CENTER);
        fill(0, 0, 255);
        textFont(fonte1);
        text("Parte 4", 595, 275, 170, 30);
        fill(0);
        textFont(fonte2);
        if(w == 0) {
          text("Finalmente, as curvas '100% em massa de austenita' (curva da esquerda, que caracteriza o in\u00edcio da transforma\u00e7\u00e3o) e '100% em massa de perlita' (curva da direita, que caracteriza o fim da transforma\u00e7\u00e3o) s\u00e3o constru\u00eddas.", 594, 328, 171, 235);
          fill(0, 0, 255);
          text("continua", 702, 513);
          image(forw, 735, 500, 20, 20);
          fill(0);
        }
        else if(w == 1) {
          text("Na regi\u00e3o do Diagrama TTT delimitada \u00e0 esquerda pelo eixo das temperaturas e \u00e0 direita pela curva '100% em massa de austenita', a amostra encontra-se integralmente na fase austenita.", 587, 332, 185, 235);
          image(forw, 748, 504, 20, 20);
          image(back, 720, 504, 20, 20);
        }
        else if (w == 2) {
          textFont(fonte7);
          text("Na regi\u00e3o correspondente a tempos maiores que os delimitados pela curva '100% em massa de perlita', a amostra possui integralmente a microestrutura perl\u00edtica. Entre as curvas '100% em massa de austenita' e '100% em massa de perlita', a amostra \u00e9 composta da fase austenita e da microestrutura perl\u00edtica (fases ferrita e cementita).", 594, 320, 180, 235);
          image(back, 738, 500, 20, 20);  
        }
      }
      else if(flag == 5) {
        text("    Reiniciar", 620, 573, 170, 30);
        image(retornar, 710, 564);
      }
    }
    textFont(fonte1);
    textAlign(CENTER);
    if(flag != 5) {
      text("Instru\u00e7\u00f5es", 595, 65, 170, 30);
      text("Cr\u00e9ditos", 595, 110, 170, 30);
      text("Refer\u00eancias", 595, 155, 170, 30);
    }
    else {
      text("Instru\u00e7\u00f5es", 600, 25, 170, 30);
      text("Cr\u00e9ditos", 600, 70, 170, 30);
      text("Refer\u00eancias", 600, 115, 170, 30);
    }
    stroke(0);
    
    // Curvas de transforma\u00e7\u00e3o - desenhando os eixos
    
    strokeWeight(2);
    line(40, 30, 40, 280);
    line(40, 280, 500, 280);
    textAlign(LEFT);
    textFont(fonte1);
    text("Tempo (s)", 504, 273);
    text("Curvas da Cin\u00e9tica de Transforma\u00e7\u00e3o Isot\u00e9rmica", 208, 24);
    textFont(fonte6);
    text("0", 87, 287);
    text("1", 157, 287);
    text("2", 227, 287);
    text("3", 298, 287);
    text("4", 366, 287);
    text("5", 438, 287);
    textFont(fonte2);
    text("% em massa de austenita\n     transformada em perlita", 38, 15);
    text("100", 15, 43);
    text("50", 20, 163);
    text("10", 72, 292);
    text("10", 142, 292);
    text("10", 212, 292);
    text("10", 283, 292);
    text("10", 351, 292);
    text("10", 423, 292);
    fill(0);
    triangle(38, 30, 42, 30, 40, 27);
    triangle(500, 278, 500, 282, 503, 280);
    for(i = 0; i <= 5; i++) {
      line(81 + 70*i, 280, 81 + 70*i, 277);
    }
    
    // Diagrama TTT - desenhando os eixos
    
    text("10", 72, 582);
    text("10", 142, 582);
    text("10", 212, 582);
    text("10", 283, 582);
    text("10", 351, 582);
    text("10", 423, 582);
    text("550", 14, 537);
    text("600", 14, 502);
    text("650", 14, 467);
    text("700", 14, 432);
    text("750", 14, 397);
    text("800", 14, 362);
    text("Temperatura eutet\u00f3ide", 380, 398);
    textFont(fonte6);
    text("0", 87, 577);
    text("1", 157, 577);
    text("2", 227, 577);
    text("3", 298, 577);
    text("4", 366, 577);
    text("5", 438, 577);
    textFont(fonte1);
    text("Diagrama TTT", 260, 324);
    line(40, 320, 40, 570);
    line(40, 570, 500, 570);
    text("Tempo (s)", 504, 563);
    text("Temperatura (\u00b0C)", 48, 324);
    triangle(38, 320, 42, 320, 40, 317);
    triangle(500, 568, 500, 572, 503, 570);
    for(i = 0; i <= 5; i++)
      line(81 + 70*i, 570, 81 + 70*i, 567);
    for(i = 0; i <= 5; i++)
      line(40, 535 - 35*i, 43, 535 - 35*i);
    if(flag == 1) {
      s[0].display();
      f[0].display();
    }
    if(flag == 2) {
      s[0].display();
      f[0].display();
      s[5].display();
      f[5].display();
    }
    if(x0 <= f[0].get_x2() + 5 && flag == 1) {
      noStroke();
      fill(255);
      rect(x0, 40, 501 - x0, 259);
      rect(x0, 400, 501 - x0, 165);
      x0 = x0 + speed;
      stroke(0);
      strokeWeight(2);
      fill(0);
      line(40, 280, 500, 280);
      triangle(500, 278, 500, 282, 503, 280);
      line(40, 570, 500, 570);
      triangle(500, 568, 500, 572, 503, 570);
      strokeWeight(1);
      for (i = 0; i <= 57; i++){
        line(40 + 8*i, 40, 44 + 8*i, 40);
        line(40 + 8*i, 160, 44 + 8*i, 160);
        line(40 + 8*i, 403, 44 + 8*i, 403);
      }
      if(x0 >= f[0].get_x1()) {
        for(j = 40; j <= 285; j++)
          for(i = PApplet.parseInt(x0) - 3; i <= PApplet.parseInt(x0) + 3; i++)
          if(get(i, j) == cor[0])
            line(x0, 550, x0, j);
      }
      strokeWeight(2);
      for(i = 0; i <= 5; i++) {
        line(81 + 70*i, 280, 81 + 70*i, 277);
      }
      textFont(fonte2);
      text("10", 72, 292);
      text("10", 142, 292);
      text("10", 212, 292);
      text("10", 283, 292);
      text("10", 351, 292);
      text("10", 423, 292);
      textFont(fonte6);
      text("0", 87, 287);
      text("1", 157, 287);
      text("2", 227, 287);
      text("3", 298, 287);
      text("4", 366, 287);
      text("5", 438, 287);  
      textFont(fonte1);
      for(i = 0; i <= 5; i++)
        line(40, 535 - 35*i, 43, 535 - 35*i);
    }
    else if(x0 <= f[5].get_x2() + 5 && flag == 2) {
      noStroke();
      fill(255);
      rect(x0, 40, 501 - x0, 259);
      rect(x0, 400, 501 - x0, 165);
      x0 = x0 + speed;
      stroke(0);
      strokeWeight(2);
      fill(0);
      line(40, 280, 500, 280);
      triangle(500, 278, 500, 282, 503, 280);
      line(40, 570, 500, 570);
      triangle(500, 568, 500, 572, 503, 570);
      strokeWeight(1);
      for (i = 0; i <= 57; i++){
        line(40 + 8*i, 40, 44 + 8*i, 40);
        line(40 + 8*i, 160, 44 + 8*i, 160);
        line(40 + 8*i, 403, 44 + 8*i, 403);
      }
      if(x0 >= f[5].get_x1()) {
        for(j = 40; j <= 285; j++)
          for(i = PApplet.parseInt(x0) - 3; i <= PApplet.parseInt(x0) + 3; i++)
          if(get(i, j) == cor[5])
            line(x0, 450, x0, j);
      }
      strokeWeight(2);
      for(i = 0; i <= 5; i++) {
        line(81 + 70*i, 280, 81 + 70*i, 277);
      }
      textFont(fonte6);
      text("0", 87, 287);
      text("1", 157, 287);
      text("2", 227, 287);
      text("3", 298, 287);
      text("4", 366, 287);
      text("5", 438, 287);
      textFont(fonte2);
      text("10", 72, 292);
      text("10", 142, 292);
      text("10", 212, 292);
      text("10", 283, 292);
      text("10", 351, 292);
      text("10", 423, 292);
      for(i = 0; i <= 5; i++)
        line(40, 535 - 35*i, 43, 535 - 35*i);
    }
    else if(flag == 3 || flag == 4 || flag == 5) {
        for(i = 0; i < 7; i++) {
          f[i].display();
          s[i].display();
        }
      if(flag == 4) {
        strokeWeight(1.5f);
        stroke(0);
        translate(-10, 60);
        bezier(90, 500, 90, 480, 80, 365, 500, 348);
        bezier(160, 500, 160, 490, 150, 380, 500, 370);
        resetMatrix();
        if(x0_2 <= 503) {
          fill(255);
          noStroke();
          rect(x0_2, 400, 501 - x0_2, 165);
          x0_2 = x0_2 + speed;
        }
        stroke(0);
        strokeWeight(2);
        fill(0);
        line(40, 570, 500, 570);
        triangle(500, 568, 500, 572, 503, 570);
        for(i = 0; i < 7; i++) {
          f[i].display();
        }
        stroke(0);
        for(i = 0; i <= 5; i++)
          line(40, 535 - 35*i, 43, 535 - 35*i);
        strokeWeight(1);
        for (i = 0; i <= 57; i++){
          line(40 + 8*i, 403, 44 + 8*i, 403);
        }
      }
      else if(flag == 5){
        for (i = 0; i < 7; i++) {
          s[i].display();
          f[i].display();
        }
        textFont(fonte1);
        fill(0, 0, 255);
        text("Extras", 658, 178);
        noFill();
        strokeWeight(1.5f);
        stroke(0);
        translate(-10, 60);
        bezier(90, 500, 90, 480, 80, 365, 500, 348);
        bezier(160, 500, 160, 490, 150, 380, 500, 370);
        resetMatrix();
        fill(0);
        textFont(fonte2);
        text("Austenita", 70, 440);
        image(seta, 130, 425, 15, 15);
        text("Perlita", 280, 500);
        image(seta, 324, 485, 15, 15);
        image(seta, 520, 383, 15, 15);
        y = mouseY;
        x = mouseX;
        
        fill(51, 79, 175);
        stroke(51, 79, 175);
        strokeWeight(1);
        ellipse(xm1, 430, 6, 6);
        
        ellipse(xm2, 550, 6, 6);
        for(i = 30; i <= 285; i++)
          if(cor[0] == get(PApplet.parseInt(xm2), i))
            ellipse(xm2, i, 6, 6);
        
        for(i = 30; i <= 285; i++)
          if(cor[6] == get(PApplet.parseInt(xm1), i))
            ellipse(xm1, i, 6, 6);
        if(y >= 425 && y <= 435 && a == 0 && q == 0 && x >= xm1 - 3 && x <= xm1 + 3 && x <= f[6].get_x2() && x >= f[6].get_x1()) {
          xm1 = x;
          aux1 = (100*((xm1 - f[6].get_x1())/(f[6].get_x2() - f[6].get_x1())));
          aux2 = (100 - aux1);
          passe = 1;
          fill(0);
        }
        else if(y >= 545 && y <= 555 && a == 0 && q == 0 && x >= xm2 - 3 && x <= xm2 + 3 && x <= f[0].get_x2() && x >= f[0].get_x1()) {
          xm2 = x;
          aux12 = (100*((xm2 - f[0].get_x1())/(f[0].get_x2() - f[0].get_x1())));
          aux22 = (100 - aux12);
          passe = 2;
          fill(0);
        }
        fill(0);
        textFont(fonte7);
        textAlign(CENTER);
        text("Passe o mouse sobre a faixa de transforma\u00e7\u00e3o temporal de temperatura mais alta do Diagrama TTT para observar a transforma\u00e7\u00e3o de austenita em perlita grossa, bem como para conhecer as fra\u00e7\u00f5es relativas em massa da austenita e da perlita grossa. Para observar a transforma\u00e7\u00e3o de austenita em perlita fina e conhecer suas fra\u00e7\u00f5es relativas em massa, passe o mouse sobre a faixa de transforma\u00e7\u00e3o temporal de temperatura mais baixa do Diagrama TTT.", 588, 200, 195, 300); 
        textFont(fonte2);
        if(passe == 1) 
          text("Porcentagem de austenita: " + nf(aux2, 2, 2) + " %\n" + "Porcentagem de perlita: " + nf(aux1, 2, 2) + " %", 580, 420, 210, 100);
        else if(passe == 2)
          text("Porcentagem de austenita: " + nf(aux22, 2, 2) + " %\n" + "Porcentagem de perlita: " + nf(aux12, 2, 2) + " %", 580, 420, 210, 100);
        contador++;
        mouse_x = mouseX;
        pmouse_x = pmouseX;
        if(passe == 1) {
          if(aux2 >= 85)
            pct = aux2/100;
          else if(contador%10 == 0 && mouse_x - pmouse_x > 0 && y >= 425 && y <= 435 && passe == 1 && mouse_x >= xm1 - 3 && mouse_x <= xm1 + 3 && mouse_x <= f[6].get_x2() && mouse_x >= f[6].get_x1())
            pct = pct - 0.02f;
          else if(aux2 > 0 && contador%10 == 0 && mouse_x - pmouse_x < 0 && y >= 425 && y <= 435 && mouse_x >= xm1 - 3 && mouse_x <= xm1 + 3 && mouse_x <= f[6].get_x2() && mouse_x >= f[6].get_x1())
            pct = pct + 0.02f; 
          Desenho(pct, aux2/100);
        }
        else if(passe == 2) {
          if(aux22 >= 85)
            pct2 = aux22/100;
          else if(contador%10 == 0 && mouse_x - pmouse_x > 0 && y >= 545 && y <= 555 && mouse_x >= xm2 - 3 && mouse_x <= xm2 + 3 && mouse_x <= f[0].get_x2() && mouse_x >= f[0].get_x1())
            pct2 = pct2 - 0.02f;
          else if(aux22 > 0 && contador%10 == 0 && mouse_x - pmouse_x < 0 && y >= 545 && y <= 555 && mouse_x >= xm2 - 3 && mouse_x <= xm2 + 3 && mouse_x <= f[0].get_x2() && mouse_x >= f[0].get_x1())
            pct2 = pct2 + 0.02f; 
          Desenho(pct2, aux22/100);
        }
        noStroke();
        fill(57, 49, 49);
        rect(635, 460, 100, 100);
        image(pg, 635, 460);
        if(q == 1) {
          noStroke();
          fill(193, 241, 245, 200);
          rect(0, 0, 900, 600);
          fill(131, 219, 227);
          strokeWeight(8);
          strokeJoin(ROUND);
          stroke(131, 219, 227, 100);
          rect(250, 200, 300, 200);
          fill(0);
          textFont(fonte5); //24
          textAlign(CENTER);
          image(fechar, 530, 202, 20, 20); 
          text("Temperatura Eutet\u00f3ide", 250, 223, 300, 40);
          textFont(fonte2);
          text("\u00c9 a temperatura caracter\u00edstica da transforma\u00e7\u00e3o eutet\u00f3ide, ou seja, a temperatura \u00fanica na qual uma fase s\u00f3lida se transforma em outras duas fases s\u00f3lidas. No nosso caso, a austenita se transforma em cementita e ferrita.", 250, 268, 300, 160);
        }
        else if(q == 2) {
          noStroke();
          fill(193, 241, 245, 200);
          rect(0, 0, 900, 600);
          fill(131, 219, 227);
          strokeWeight(8);
          strokeJoin(ROUND);
          stroke(131, 219, 227, 100);
          rect(250, 195, 300, 220);
          fill(0);
          textFont(fonte5);
          textAlign(CENTER);
          image(fechar, 530, 202, 20, 20); 
          text("Austenita", 250, 220, 300, 40);
          textFont(fonte1);
          text("Solu\u00e7\u00e3o s\u00f3lida intersticial de carbono no ferro-gama (estrutura cristalina c\u00fabica de faces centradas).\n\nVer micrografia", 250, 270, 300, 110);
          image(foto, 480, 355);
          if(r == 1) {
            fill(131, 219, 227);
            rect(250, 195, 300, 220);
            image(fechar, 530, 202, 20, 20);
            image(austenita, 325, 203, 150, 180);
            image(back, 500, 350);
            fill(0);
            textFont(fonte6);
            text("CALLISTER, William D. Materials science and engineering: an introduction. 7a. ed. Nova York: John Wiley and Sons, 2007. p. 291", 250, 385, 295, 50);
          }
        }
        else if(q == 3) {
          noStroke();
          fill(193, 241, 245, 200);
          rect(0, 0, 800, 600);
          fill(131, 219, 227);
          strokeWeight(8);
          strokeJoin(ROUND);
          stroke(131, 219, 227, 100);
          rect(200, 150, 400, 300);
          fill(0);
          textFont(fonte5);
          textAlign(CENTER);
          image(fechar, 570, 154, 20, 20); 
          text("Perlita", 250, 160, 300, 30);
          textFont(fonte2);
          text("Microestrutura formada por camadas de cementita (Fe  C) em uma matriz de ferrita*. Distinguimos dois tipos de perlita: grossa e fina. A perlita grossa ocorre em temperaturas mais altas, pr\u00f3ximas \u00e0 eutet\u00f3ide. Devido \u00e0s taxas de difus\u00e3o mais elevadas, os gr\u00e3os da perlita grossa s\u00e3o maiores, e as lamelas de cementita e ferrita, mais espessas do que na perlita fina. A perlita fina ocorre em temperaturas mais baixas, para as quais a difus\u00e3o \u00e9 mais lenta. A essas temperaturas, as taxas de nuclea\u00e7\u00e3o s\u00e3o maiores e desenvolve-se uma estrutura de lamelas mais finas.\n*Ferrita: solu\u00e7\u00e3o s\u00f3lida intersticial de carbono no ferro alfa (estrutura cristalina c\u00fabica de corpo centrado).", 210, 190, 380, 420);
          textFont(fonte6);
          text("3", 541, 204);
          textFont(fonte1);
          text("Ver micrografias", 402, 425);
          image(foto, 480, 400);
          if(r == 1) {
            fill(131, 219, 227);
            rect(200, 150, 400, 300);
            image(fechar, 570, 154, 20, 20);
            image(pgrossa, 220, 170, 120, 240);
            image(pfina, 355, 170, 120, 240);
            fill(0);
            textFont(fonte2);
            text("(a) Perlita grossa\n\n\n(b) Perlita fina", 485, 250, 100, 200);
            textFont(fonte6);
            text("<http://www.cimm.com.br/portal/material_didatico/6439-transformacoes#.T9-0JRf2YxE> Acesso em 18/06/2012", 220, 415, 250, 100);
            image(back, 550, 410);
          }
        }
      }
    }
    if(flag == 1 && x0 >= f[0].get_x1()) {
      fill(255, 0, 0);
      strokeWeight(1);
      stroke(255, 0, 0);
      for(i = 40; i <= f[0].get_x1() - 4; i+= 8)
        line(i, 550, i + 4, 550); 
      textFont(fonte2);
      text("529 \u00baC", 85, 100);
      text("529", 15, 555);
      fill(0);
      stroke(0);
      strokeWeight(2);
      //textFont(fonte1);
    }
    else if(flag == 2 && x0 >= f[5].get_x1()) {
      fill(255, 0, 0);
      strokeWeight(1);
      stroke(255, 0, 0);
      for(i = 40; i <= f[5].get_x1() - 4; i+= 8)
        line(i, 450, i + 4, 450); 
      textFont(fonte2);
      text("672 \u00baC", 230, 100);
      text("672", 15, 452);
      fill(0);
      stroke(0);
      strokeWeight(2);
      //textFont(fonte1);
    }
  }
  if(a == 1) {
    noStroke();
    fill(193, 241, 245, 200);
    rect(0, 0, 900, 600);
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    rect(140, 110, 520, 380);
    fill(0);
    textFont(fonte5);
    textAlign(CENTER);
    image(fechar, 630, 120, 20, 20); 
    text("Instru\u00e7\u00f5es", 250, 124, 300, 30);
    textFont(fonte2);
    text("\n\nEsta anima\u00e7\u00e3o \u00e9 composta de quatro partes, cada uma ilustrando uma etapa da constru\u00e7\u00e3o do Diagrama TTT, a partir das curvas de transforma\u00e7\u00e3o de austenita em perlita. Ao final da quarta parte, voc\u00ea tem a op\u00e7\u00e3o de reiniciar a anima\u00e7\u00e3o ou de seguir para a se\u00e7\u00e3o 'Extras'.", 160, 122, 480, 380);
    textFont(fonte1);
    text("\n\n\nExtras", 160, 188, 480, 380);
    textFont(fonte2);
    text("\n\n\nQuando nesta se\u00e7\u00e3o, passe o mouse sobre a faixa de transforma\u00e7\u00e3o temporal de maior temperatura no Diagrama TTT para observar" +
    "uma ilustra\u00e7\u00e3o gr\u00e1fica da evolu\u00e7\u00e3o temporal da microestrutura de uma amostra durante a tranforma\u00e7\u00e3o da fase austenita na microestrutura perlita grossa, bem como para conhecer as fra\u00e7\u00f5es relativas em massa da austenita e da perlita grossa. Analogamente, passe o mouse sobre a faixa de transforma\u00e7\u00e3o temporal de menor temperatura no Diagrama TTT para observar a transforma\u00e7\u00e3o de fase da austenita em perlita fina e conhecer suas fra\u00e7\u00f5es relativas em massa.", 160, 230, 480, 380);
    text("\nAqui, voc\u00ea tamb\u00e9m pode clicar sobre as setas          para saber mais sobre o significado do termo ao lado do qual cada uma delas se encontra.", 160, 420, 480, 380);
    image(seta, 455, 437, 15, 15);
  }
  else if(a == 2) {
    noStroke();
    fill(193, 241, 245, 200);
    rect(0, 0, 900, 600);
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    rect(140, 90, 520, 370);
    fill(0);
    textFont(fonte5);
    textAlign(CENTER);
    image(fechar, 630, 98, 20, 20); 
    text("Cr\u00e9ditos", 250, 113, 300, 30);
    textFont(fonte2);
    textAlign(LEFT);
    if(t == 0) {
      fill(22, 79, 167);
      text("Sobre o Processing", 475, 430);
      image(forw, 600, 412);
      fill(0);
      text("Desenvolvimento: Luana Ianara Rubini Ruiz (Aluna do 2\u00ba ano do Curso de Engenharia El\u00e9trica - Sistemas Eletr\u00f4nicos, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)\nTexto: Luana Ianara Rubini Ruiz e Ivette Frida Cymbaum Oppenheim\nCriado em: Processing                    \u00daltima atualiza\u00e7\u00e3o: 10/dezembro/2012", 156, 148, 500, 420);
      text("\nApoio: A simula\u00e7\u00e3o 'Diagrama de Transforma\u00e7\u00e3o Isot\u00e9rmica Tempo-Temperatura' foi desenvolvida no contexto do projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo, \u00e0 qual expressamos nossos agradecimentos pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica (Projeto 5767 - ano 2012).", 156, 291, 500, 420);  
    }
    else if(t == 1) {
      image(back, 550, 400);
      textAlign(CENTER);
      text("'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desenvolvimento com foco principal nas artes visuais, aproveitando-se da plataforma Java e de uma comunidade virtual intensamente atuante por meio do compartilhamento de c\u00f3digos e bibliotecas atrav\u00e9s da Internet. Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisadores do Instituto de Tecnologia de Massachussets (MIT) dos E.U.A, sendo, desde sua cria\u00e7\u00e3o em 2001, disponibilizado gratuitamente como software livre, acess\u00edvel a qualquer interessado a partir do download no site \u2018processing.org', onde podem ser encontradas informa\u00e7\u00f5es adicionais sobre 'Processing'.", 180, 190, 440, 410);
      textAlign(LEFT);
    }
  }
  else if(a == 3) {
    noStroke();
    fill(193, 241, 245, 200);
    rect(0, 0, 900, 600);
    fill(131, 219, 227);
    strokeWeight(8);
    strokeJoin(ROUND);
    stroke(131, 219, 227, 100);
    rect(140, 110, 520, 330);
    fill(0);
    textFont(fonte5);
    textAlign(CENTER);
    image(fechar, 630, 120, 20, 20);
    if(t != 2)
      text("Refer\u00eancias", 250, 125, 300, 30);
    else
      text("Refer\u00eancias (\u00edcones)", 250, 125, 300, 30);
    textFont(fonte2);
    textAlign(LEFT);
    if(t == 0) {
      image(forw, 600, 400);
      text("Material did\u00e1tico da disciplina 'Introdu\u00e7\u00e3o \u00e0 Ci\u00eancia dos Materiais para Engenharia - PMT2100', Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, slides da aula te\u00f3rica 'Diagramas de fase II/Transforma\u00e7\u00f5es de fase', ano 2011.\n\n Laborat\u00f3rio de Material Did\u00e1tico Multim\u00eddia, CETEC-MG. 'Mudan\u00e7a de Estrutura'. Ci\u00eancia dos Materiais Multim\u00eddia.\nhttp://www.cienciadosmateriais.org/index.php?acao=exibir&cap=21&top=139\nAcesso em 18 jun. 2012\n\nCALLISTER, William D., Materials science and engineering: an introduction. 7a. ed. Nova York: John Wiley and Sons, 2007. P\u00e1ginas 290 a 295.\n\n", 170, 195, 480, 420);
    }
    else if(t == 1) {
      image(back, 550, 400);
      text("'Phase Transformations in Metals'.\nhttp://www.virginia.edu/bohr/mse209/chapter10.htm\nAcesso em 25 jun. 2012\n\n'Phase Transformations in Metals'. Introduction to Materials Science.\nhttp://www.synl.ac.cn/org/non/zu1/knowledge/phase.pdf\nAcesso em 25 jun. 2012\n\n'Transforma\u00e7\u00f5es'. Centro de Informa\u00e7\u00e3o Metal Mec\u00e2nica.\nhttp://www.cimm.com.br/portal/material_didatico/6439-transformacoes#.T9-0JRf2YxE\nAcesso em 11 jul. 2012", 162, 175, 480, 420);
      image(forw, 600, 400);
    }
    else if(t == 2) {
      textFont(fonte5);
      textFont(fonte2);
      image(back, 550, 400);
      text("\nhttp://www.iconesbr.net/down_ico/6971/setas. Acesso em 11 jul. 2012\n\nhttp://www.iconesbr.net/down_ico/11631/windows_7_473. Acesso em 25 jun. 2012\n\nhttp://www.iconesbr.net/down_ico/6980/setas. Acesso em 11 jul. 2012\n\nhttp://www.iconesbr.net/down_ico/1969/front. Acesso em 23 jun. 2012\n\nhttp://www.iconesbr.net/down_ico/4445/d3a_big_pack_photoapp. Acesso em 23 jun. 2012\n\nhttp://www.iconesbr.net/down_ico/11291/windows_7_167\nAcesso em 23 jun. 2012", 180, 145, 465, 420);
      image(forw, 150, 163, 20, 20);
      image(play, 150, 206, 20, 20);
      image(retornar, 150, 257, 20, 20);
      image(seta, 150, 294, 20, 20);
      image(foto, 150, 340, 25, 25);
      image(fechar, 156, 390, 20, 20);
    }
  }
}

class Curvas {
  
  float ax1, ay1, w, h;
  int c;
  
  Curvas(float temp_ax1, float temp_ay1, float temp_w, float temp_h, int temp_c) {
    ax1 = temp_ax1;
    ay1 = temp_ay1;
    w = temp_w;
    h = temp_h;
    c = temp_c;
  }
  
  public void display () {
    smooth();
    noFill();
    stroke(c);
    strokeWeight(2);
    bezier(ax1, ay1, ax1 + 30, ay1, ax1 + w - 30, ay1 - h, ax1 + w, ay1 - h); 
  }
  
  public void set_cor(int cor) {
    c = cor;
  }
  
}
// AGRADECIMENTO AO GUSTAVO
float Agrao;

public void Desenho(float W2, float W3) { 
  pg.beginDraw();
  pg.fill(57, 49, 49);
  pg.smooth();
  pg.strokeWeight(2);
  if(passe == 1)
    pg.image(pgrossa, 0, 0, 168, 150);
  else if(passe == 2)
    pg.image(pfina, 0, 0, 168, 150);
  pg.fill(57, 49, 49);
  //if(W2 > 0.85){
    DrawGrao(pg, 0, 1*W2);
    DrawGrao(pg, 1, 1*W2);
    DrawGrao(pg, 2, 1*W2);
    DrawGrao(pg, 3, 1*W2);
  /*}
  else {
   DrawGrao(pg, 0, 0.85);
   DrawGrao(pg, 1, 0.85);
   DrawGrao(pg, 2, 0.85);
   DrawGrao(pg, 3, 0.85);
  } */
  if(W3 < 0.85f) {
    pg.imageMode(CENTER);
    if(passe == 1) {
      pg.image(grao1, 50, 46.5f, 57*(0.85f-W3)*1/0.85f, 41*(0.85f-W3)*1/0.85f);
      pg.image(grao2, 92, 56, 50*(0.85f-W3)*1/0.85f, 76*(0.85f-W3)*1/0.85f);
      pg.image(grao3, 50, 15, 101*(0.85f-W3)*1/0.85f, 43*(0.85f-W3)*1/0.85f);
      pg.image(grao4, 10, 50, 44*(0.85f-W3)*1/0.85f, 73*(0.85f-W3)*1/0.85f);
      pg.image(grao5, 50, 90, 95*(0.85f-W3)*1/0.85f, 60*(0.85f-W3)*1/0.85f);
    }
    else if (passe == 2) {
      pg.image(g1, 50, 46.5f, 57*(0.85f-W3)*1/0.85f, 41*(0.85f-W3)*1/0.85f);
      pg.image(g2, 92, 56, 50*(0.85f-W3)*1/0.85f, 76*(0.85f-W3)*1/0.85f);
      pg.image(g3, 50, 15, 101*(0.85f-W3)*1/0.85f, 43*(0.85f-W3)*1/0.85f);
      pg.image(g4, 10, 50, 44*(0.85f-W3)*1/0.85f, 73*(0.85f-W3)*1/0.85f);
      pg.image(g5, 50, 90, 95*(0.85f-W3)*1/0.85f, 60*(0.85f-W3)*1/0.85f);
    }
    pg.imageMode(CORNER);
  }
  pg.endDraw();
}
class Faixas {
  
  float x1, y1, w;
  int c;
  
  Faixas(float temp_x1, float temp_y1, float temp_w, int temp_c) {
    x1 = temp_x1;
    y1 = temp_y1;
    w = temp_w;
    c = temp_c;
  }
  
  public void display() {
    smooth();
    noFill();
    stroke(c);
    strokeWeight(2);
    line(x1, y1, x1 + w, y1);
  }
  
  public void set_cor(int cor) {
    c = cor;
  }
  
  public float get_x1() {
   return x1;
  }
  
  public float get_x2() {
   return x1 + w; 
  }
  
}
public void mousePressed() {
  int ics, igrec;
  ics = mouseX;
  igrec = mouseY;
  if(p == 0) {
    p = 1;
    flag = 0;
    ics = 1000;
    igrec = 1000;
  }
  else if((p == 2 || p == 3) && 640 <= ics && ics <= 715 && igrec <= 350 && igrec >= 310)
    p = 1;
  else if((p == 1 || p == 3) && 722.5f <= ics && ics <= 797.5f && igrec <= 350 && igrec >= 310)
    p = 2;
  else if((p == 1 || p == 2) && 805 <= ics && ics <= 880 && igrec <= 350 && igrec >= 310)
    p = 3;
  if(p != 0 && a == 0 && q == 0 && flag == 0 && ics >= 730 && ics <= 762 && igrec >= 540 && igrec <= 572) {
    flag = 1;
    ics = 1000;
    igrec = 1000;
  }
  else if(p != 0 && a == 0 && q == 0 && flag == 1 && ics >= 710 && ics <= 742 && igrec >= 540 && igrec <= 572) {
    flag = 2;
    x0 = f[5].get_x1();
    ics = 1000;
    igrec = 1000;
  }
  else if(p != 0 && a == 0 && q == 0 && flag == 2 && ics >= 710 && ics <= 742 && igrec >= 540 && igrec <= 572) {
    flag = 3;
    ics = 1000;
    igrec = 1000;
  }
  else if(p != 0 && a == 0 && flag == 3 && q == 0 && ics >= 710 && ics <= 742 && igrec >= 540 && igrec <= 572) {
    flag = 4;
    ics = 1000;
    igrec = 1000;
  }
  else if(p != 0 && a == 0 && q == 0 && flag == 4 && ics >= 708 && ics <= 740 && igrec >= 567 && igrec <= 597) {
    flag = 5;
    ics = 1000;
    igrec = 1000;
  }
  else if(p != 0 && a == 0 && q == 0 && flag == 4 && ics >= 710 && ics <= 742 && igrec >= 534 && igrec <= 566) {
    flag = 1;
    x0 = 41;
    x0_2 = 45;
    aux2 = 100;
    aux1 = 0;
    w = 0;
  }
  else if(p != 0 && a == 0 && q == 0 && flag == 5 && ics >= 710 && ics <= 742 && igrec >= 564 && igrec <= 596) {
    flag = 1;
    x0 = 41;
    x0_2 = 45;
    aux2 = 100;
    aux1 = 0;
    w = 0;
  }
  if(p != 0 && a == 0 && q == 0 && ics >= 520 && ics <= 535 && igrec >= 383 && igrec <= 398) 
    q = 1;
  if(p != 0 && a == 0 && q == 0 && ics >= 130 && ics <= 145 && igrec >= 425 && igrec <= 440) 
    q = 2;
  if(p != 0 && a == 0 && q == 0 && ics >= 324 && ics <= 339 && igrec >= 485 && igrec <= 500) 
    q = 3;
  if((q == 1 || q == 2 || q == 4) && ics >= 530 && ics <= 550 && igrec >= 202 && igrec <= 222) {
    q = 0;
    r = 0;
  }
  if(q == 3 && ics >= 570 && ics <= 590 && igrec >= 154 && igrec <= 174) {
    q = 0;
    r = 0;
  }
  if((q == 2) && ics >= 480 && ics <= 512 && igrec >= 355 && igrec <= 387)
    r = 1;
  if((q == 3) && ics >= 480 && ics <= 512 && igrec >= 400 && igrec <= 432)
    r = 1;
  if(q == 2 && r == 1 && ics >= 500 && ics <= 532 && igrec >= 350 && igrec <= 382)
    r = 0;
  if((q == 3) && ics >= 550 && ics <= 582 && igrec >= 410 && igrec <= 442)
    r = 0;
  if(flag != 5 && a == 0 && q == 0 && ics >= 595 && ics <= 765 && igrec >= 60 && igrec <= 90 && p != 0)
    a = 1;
  else if(flag != 5 && a == 0 && q == 0 && ics >= 595 && ics <= 765 && igrec >= 105 && igrec <= 135 && p != 0) {
    a = 2;
    t = 0;
  }
  else if(flag != 5 && a == 0 && q == 0 && ics >= 595 && ics <= 765 && igrec >= 150 && igrec <= 180 && p != 0) {
    a = 3;
    t = 0;
  }
  
  if(flag == 5 && a == 0 && q == 0 && ics >= 595 && ics <= 765 && igrec >= 20 && igrec <= 50 && p != 0)
    a = 1;
  else if(flag == 5 && a == 0 && q == 0 && ics >= 600 && ics <= 770 && igrec >= 65 && igrec <= 95 && p != 0) {
    a = 2;
    t = 0;
  }
  else if(flag == 5 && a == 0 && q == 0 && ics >= 600 && ics <= 770 && igrec >= 110 && igrec <= 140 && p != 0) {
    a = 3;
    t = 0;
  }
  
  if((a == 3 || a == 1) && ics >= 630 && ics <= 650 && igrec >= 120 && igrec <= 140) {
    a = 0;
  }
  else if(a == 2 && igrec >= 98 && igrec <= 118 && ics >= 630 && ics <= 650)
    a = 0;
  if(a == 2 && t == 0 && ics >= 600 && ics <= 632 && igrec >= 412 && igrec <= 444) {
    t = 1;
    ics = 1000;
    igrec = 1000;
  }
  if(a == 3 && t == 0 && ics >= 600 && ics <= 632 && igrec >= 400 && igrec <= 432) {
    t = 1;
    ics = 1000;
    igrec = 1000;
  }
  if(t == 1 && ics >= 600 && ics <= 632 && igrec >= 400 && igrec <= 432)
    t = 2;
  if(t == 1 && ics >= 550 && ics <= 582 && igrec >= 400 && igrec <= 432)
    t = 0;
  if(t == 2 && ics >= 550 && ics <= 582 && igrec >= 400 && igrec <= 432)
    t = 1;
  if (flag == 4 && w == 0 && a == 0 && q == 0 && ics >= 735 && ics <= 755 && igrec >= 500 && igrec <= 520) {
    w = 1;
    ics = 1000;
    igrec = 1000;
  }
  else if(flag == 4 && w == 1 && a == 0 && q == 0 && ics >= 748 && ics <= 768 && igrec >= 504 && igrec <= 524) {
    w = 2;
    ics = 1000;
    igrec = 1000;
  }
  else if(flag == 4 && w == 1 && a == 0 && q == 0 && ics >= 720 && ics <= 740 && igrec >= 504 && igrec <= 524) {
    w = 0;
    ics = 1000;
    igrec = 1000;
  }
  else if(flag == 4 && w == 2 && a == 0 && q == 0 && ics >= 738 && ics <= 758 && igrec >= 500 && igrec <= 520) {
    w = 1;
    ics = 1000;
    igrec = 1000;
  }
}
//AGRADECIMENTO AO GUSTAVO

public void DrawGrao(PGraphics pg, int tipo, float tamanho) {
  pg.beginDraw();
  if(tamanho == 1)
    pg.stroke(80, 80, 80);
  else
    pg.stroke(57, 49, 49);
  if(tipo == 0){
    pg.pushMatrix();
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(1.0f, 44.0f);
    pg.bezierVertex(1.0f, 44.0f, 27.0f, 51.0f, 30.0f, 42.0f);
    pg.bezierVertex(33.0f, 33.0f, 49.0f, 34.0f, 46.0f, 23.0f);
    pg.bezierVertex(43.0f, 12.0f, 47.0f, 1.0f, 47.0f, 1.0f);
    pg.bezierVertex(47.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f);
    pg.bezierVertex(0.0f, 0.0f, 0.0f, 43.0f, 0.0f, 43.0f);
    pg.endShape();
    pg.popMatrix();
  }

  if(tipo == 1){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 0);
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(40.0f, 32.0f);
    pg.bezierVertex(40.0f, 32.0f, 50.0f, 44.0f, 59.0f, 48.0f);
    pg.bezierVertex(68.0f, 52.0f, 57.0f, 44.0f, 69.0f, 52.0f);
    pg.bezierVertex(81.0f, 60.0f, 82.0f, 61.0f, 84.0f, 60.0f);
    pg.bezierVertex(86.0f, 59.0f, 100.0f, 59.0f, 100.0f, 59.0f);
    pg.bezierVertex(100.0f, 59.0f, 100.0f, -1.0f, 100.0f, 0.0f);
    pg.bezierVertex(100.0f, 1.0f, 46.0f, -1.0f, 46.0f, 0.0f);
    pg.bezierVertex(46.0f, 1.0f, 43.0f, 25.0f, 47.0f, 26.0f);
    pg.bezierVertex(51.0f, 27.0f, 40.0f, 31.0f, 40.0f, 32.0f);
    pg.endShape();
    pg.popMatrix();
  }
  if(tipo == 2){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));

    pg.beginShape();
    pg.vertex(57.0f, 47.0f);
    pg.bezierVertex(57.0f, 47.0f, 45.0f, 65.0f, 45.0f, 69.0f);
    pg.bezierVertex(45.0f, 73.0f, 41.0f, 83.0f, 42.0f, 91.0f);
    pg.bezierVertex(43.0f, 99.0f, 43.0f, 100.0f, 43.0f, 100.0f);
    pg.bezierVertex(43.0f, 100.0f, 100.0f, 99.0f, 100.0f, 100.0f);
    pg.bezierVertex(100.0f, 101.0f, 101.0f, 58.0f, 101.0f, 58.0f);
    pg.bezierVertex(101.0f, 58.0f, 85.0f, 58.0f, 84.0f, 61.0f);
    pg.bezierVertex(83.0f, 64.0f, 63.0f, 46.0f, 63.0f, 49.0f);
    pg.bezierVertex(63.0f, 52.0f, 57.0f, 47.0f, 57.0f, 47.0f);
    pg.endShape();
    pg.popMatrix();
  }
  if (tipo == 3){ 
    pg.pushMatrix();
    pg.translate(0, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(41.0f, 33.0f);
    pg.bezierVertex(41.0f, 33.0f, 57.0f, 50.0f, 57.0f, 47.0f);
    pg.bezierVertex(57.0f, 44.0f, 43.0f, 69.0f, 45.0f, 69.0f);
    pg.bezierVertex(47.0f, 69.0f, 39.0f, 86.0f, 43.0f, 92.0f);
    pg.bezierVertex(47.0f, 98.0f, 44.0f, 100.0f, 44.0f, 100.0f);
    pg.bezierVertex(44.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f);
    pg.bezierVertex(0.0f, 100.0f, 1.0f, 43.0f, 1.0f, 43.0f);
    pg.bezierVertex(1.0f, 43.0f, 17.0f, 50.0f, 25.0f, 46.0f);
    pg.bezierVertex(33.0f, 42.0f, 25.0f, 46.0f, 25.0f, 46.0f);
    pg.bezierVertex(25.0f, 46.0f, 40.0f, 32.0f, 41.0f, 30.0f);
    pg.endShape();
    pg.popMatrix();
  }

  pg.endDraw();
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Diagrama_TTT" });
  }
}
